    # CleverClay.rb
    # Version: 1.01
    # Turns all materials Gray but keeps transparency if any
    # Jan Sandstrm www.pixero.com
    # Based on Thomthoms "Blackout" 

    require 'sketchup.rb'

    #-----------------------------------------------------------------------
    is_this_file=File.basename(__FILE__)
    if not file_loaded?(is_this_file)
      UI.menu("Plugins").add_item("JS Clever Clay"){Clay.claymaker}
    end
    #-----------------------------------------------------------------------
    file_loaded(is_this_file)
	module Clay
       def self.claymaker
          # Make use of the SU7 speed boost with start_operation while making sure it works in SU6.
          if Sketchup.version.split('.')[0].to_i >= 7
             Sketchup.active_model.start_operation("claymaker", true)
          else
             Sketchup.active_model.start_operation("claymaker")
          end
          
             model = Sketchup.active_model
             materials = model.materials
             entities = model.entities
             
             m = materials.add "ClayMat"
             m.color = [200, 200, 200]
             m.alpha = 1
			 
			 g = materials.add "TranspMat"
			 g.color = [0, 0, 0]
             g.alpha = 20

          entities.each { | e |
             if (e.material == nil) && (e.kind_of?(Sketchup::Face))
                e.material = "ClayMat"
                e.back_material = "ClayMat" if e.respond_to? "back_material"
             end
             if (e.kind_of?(Sketchup::Face) && (e.material.alpha < 1 ))
				e.material = "TranspMat"
                #e.material.texture = nil
                #e.material.color = [200, 200, 200]
             end
             if (e.kind_of?(Sketchup::Face) && (e.material.alpha == 1 ))
                e.material = "ClayMat"
                e.back_material = "ClayMat" if e.respond_to? "back_material"
             end
          }
     
        # Loop over all the definitions in the model
        model.definitions.each { |d|
         d.entities.each { |e|
            if (e.material == nil) && (e.kind_of?(Sketchup::Face))
                e.material = "ClayMat"
                e.back_material = "ClayMat" if e.respond_to? "back_material"
             end
             if (e.kind_of?(Sketchup::Face) && (e.material.alpha < 1 ))
                e.material = "TranspMat"
                #e.material.texture = nil
                #e.material.color = [200, 200, 200]
             end
             if (e.kind_of?(Sketchup::Face) && (e.material.alpha == 1 ))
                e.material = "ClayMat"
                e.back_material = "ClayMat" if e.respond_to? "back_material"
             end
         }
        }  
		
          Sketchup.active_model.commit_operation
       end
	end

